package com.fp.persistence.pgeneral.gene;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENETRANSACTIONREPORTLINK*/
@Entity(name="TgeneTransactionReportLink")
@Table(name="TGENETRANSACTIONREPORTLINK")
public class TgeneTransactionReportLink extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneTransactionReportLink
*/
@EmbeddedId
private TgeneTransactionReportLinkKey pk;
@Column(name="PERSISTENCEUNIT", nullable=true)

/**
* Nombre del persistence unit, si esta en null toma la coneccion por defecto de la compania
*/
private String persistenceunit;

@Column(name="REPORTNAME", nullable=false)

/**
* Nombre del reporte
*/
private String reportname;

/**Contructor por defecto*/
public TgeneTransactionReportLink(){
}
/**Contructor de TgeneTransactionReportLink
@param pPk Clave Primaria del entity
@param pReportname Nombre del reporte
*/
public TgeneTransactionReportLink(TgeneTransactionReportLinkKey pPk,String pReportname){
 this();
 pk=pPk;
 reportname=pReportname;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneTransactionReportLink
*/
public static TgeneTransactionReportLink find(EntityManager pEntityManager,TgeneTransactionReportLinkKey pKey) throws Exception{
    TgeneTransactionReportLink obj = pEntityManager.find(TgeneTransactionReportLink.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneTransactionReportLink
@return El objeto que referencia a la Clave primaria de TgeneTransactionReportLink
*/
public TgeneTransactionReportLinkKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneTransactionReportLink
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneTransactionReportLink
*/
public void setPk(TgeneTransactionReportLinkKey pPk){
  pk=pPk;
}
/**Obtiene el valor de persistenceunit
@return valor de persistenceunit*/
public String getPersistenceunit(){
  return persistenceunit;
}
/**Fija el valor de persistenceunit
@param pPersistenceunit nuevo Valor de persistenceunit*/
public void setPersistenceunit(String pPersistenceunit){
  persistenceunit=pPersistenceunit;
}

/**Obtiene el valor de reportname
@return valor de reportname*/
public String getReportname(){
  return reportname;
}
/**Fija el valor de reportname
@param pReportname nuevo Valor de reportname*/
public void setReportname(String pReportname){
  reportname=pReportname;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneTransactionReportLink))return false;
    TgeneTransactionReportLink that = (TgeneTransactionReportLink) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneTransactionReportLink
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneTransactionReportLink
*/
public Object createInstance(){
 TgeneTransactionReportLink instance=new TgeneTransactionReportLink();	
 instance.setPk(new TgeneTransactionReportLinkKey());
 return instance;
}
/**Clona la entidad TgeneTransactionReportLink
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneTransactionReportLink p=(TgeneTransactionReportLink)this.clone();
  p.setPk((TgeneTransactionReportLinkKey)this.pk.cloneMe());
  return p;
}
}
